import Flutter
import UIKit


public class SwiftFlutterHesabePlugin: NSObject, FlutterPlugin, UINavigationControllerDelegate {
    var results : FlutterResult!
    var navigationController: UINavigationController!

    override init(){
        super.init()
    }

 public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_hesabe_payment", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterHesabePlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      results = result

        if(call.method.elementsEqual("payment"))
        {

     	   let arguments = call.arguments as! NSDictionary
     	  // let arguments = call.arguments as! [String:Any]

	        var price : String!
            if let amount = arguments["price"] as? Double{
                price = String(amount)
            }else{
                price = "0.0"
            }

            var paymentRequest_ = PaymentRequest(amount: price)

            let vc = HesabeGatewayVC()

			vc.paymentRequest = paymentRequest_

			vc.url = arguments["cred_url"] as? String ?? ""

            vc.modalPresentationStyle = .overFullScreen // to

            navigationController.present(vc, animated: true, completion: nil)
        }
    }
}